<?php

namespace SGalinski\SgJobs\Domain\Repository;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use TYPO3\CMS\Core\Database\DatabaseConnection;
use TYPO3\CMS\Extbase\Persistence\Repository;

/**
 * Company Repository
 */
class CompanyRepository extends Repository {

	/**
	 * initializes the object
	 */
	public function initializeObject() {
		$querySettings = $this->createQuery()->getQuerySettings();
		$querySettings->setRespectStoragePage(FALSE);
		$querySettings->setIgnoreEnableFields(TRUE);
		$querySettings->setEnableFieldsToBeIgnored(['disabled']);
		$this->setDefaultQuerySettings($querySettings);
	}

	/**
	 * @param int $pageUid
	 * @return mixed
	 */
	public function getAllCountries($pageUid) {
		/** @var DatabaseConnection $db */
		$db = $GLOBALS['TYPO3_DB'];
		$result = $db->exec_SELECTquery(
			'country', 'tx_sgjobs_domain_model_company', 'pid = ' . $pageUid, 'country'
		)->fetch_all();

		$countryArray = [];
		$countryArray[] = '';
		foreach($result as $country) {
			$countryArray[] = $country[0];
		}

		return $countryArray;
	}

	/**
	 * @param int $pageUid
	 * @return mixed
	 */
	public function getAllCities($pageUid) {
		/** @var DatabaseConnection $db */
		$db = $GLOBALS['TYPO3_DB'];
		$result = $db->exec_SELECTquery(
			'city', 'tx_sgjobs_domain_model_company', 'pid = ' . $pageUid, 'city'
		)->fetch_all();

		$cityArray = [];
		$cityArray[] = '';
		foreach($result as $city) {
			$cityArray[] = $city[0];
		}

		return $cityArray;
	}

	/**
	 * @param int $pageUid
	 * @return mixed
	 */
	public function getAllCompanyNames($pageUid) {
		/** @var DatabaseConnection $db */
		$db = $GLOBALS['TYPO3_DB'];
		$result = $db->exec_SELECTquery(
			'name', 'tx_sgjobs_domain_model_company', 'pid = ' . $pageUid, 'name'
		)->fetch_all();

		$namesArray = [];
		$namesArray[] = '';
		foreach($result as $name) {
			$namesArray[] = $name[0];
		}

		return $namesArray;
	}
}
